import 'package:like_sealed/like_sealed.dart';
import 'dart:math' as math;
import 'sample_model.dart' as model;

part 'state.sealed.dart';

@LikeSealed(switchImpl: true)
abstract class State {}

class StateWithSuffix extends State {
  final math.Random random;
  final model.SampleModule sampleModel;

  StateWithSuffix(
      {required this.random, this.sampleModel = const model.SampleModule()});
}

class StateInit extends State {
  StateInit();
}

class StateData extends State {
  final String message;

  StateData(this.message);
}

class StateProgress extends State {
  final Future future;
  final String? arg;
  final String? argg;
  final String? arggg;

  StateProgress(this.future, [this.arg, this.argg, this.arggg]);
}

class StateNamed extends State {
  final String? arg;
  final String? argg;
  final String? arggg;

  StateNamed()
      : arg = null,
        arggg = null,
        argg = null;

  StateNamed.named(this.arg, {this.argg, this.arggg});
}

class StateOnlyNamed extends State {
  final String? arg;
  final String? argg;
  final String? arggg;

  StateOnlyNamed({this.arg, this.argg, this.arggg});
}

class StateOptional extends State {
  final String? arg;
  final String? argg;
  final String? arggg;

  StateOptional([this.arg, this.argg, this.arggg]);
}

class StateWithDefault extends State {
  final String arg;
  final Type type;
  final double number;

  StateWithDefault({
    this.arg = "String",
    this.type = DateTime,
    this.number = 1.0,
  });
}
