import 'package:analyzer/dart/element/element.dart';
import 'package:like_sealed_gen/src/content/sealed_collection_content.dart';
import 'package:like_sealed_gen/src/content/sealed_switch_content.dart';
import 'package:like_sealed_gen/src/content/sealed_switch_impl_content.dart';

class ContentFormat {
  final imports = <String>[];
  final bool isShortName;
  final bool isCollection;
  final bool isSwitchInterface;
  final bool isSwitchImpl;

  ContentFormat(
    this.isShortName,
    this.isCollection,
    this.isSwitchInterface,
    this.isSwitchImpl,
  );

  String build(
    List<ImportElement> importElement,
    String className,
    List<ClassElement> types,
  ) {
    var content = "";
    if (isCollection) {
      content += SealedCollectionContent(
        isShortName,
        className,
        types,
        importElement,
      ).content();
    }
    if (isSwitchInterface) {
      content += SealedSwitchContent(isShortName, className, types).content();
    }
    if (isSwitchImpl) {
      content +=
          SealedSwitchImplContent(isShortName, className, types).content();
    }
    return content;
  }
}
